package com.gic.evaluate.dao.mapper;

import com.gic.evaluate.dto.ProblemDTO;
import com.gic.evaluate.entity.TabProblem;
import com.gic.evaluate.qo.ProblemQO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface TabProblemMapper {
    /**
     * 根据主键删除
     *
     * @param problemId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer problemId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabProblem record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabProblem record);

    /**
     * 根据主键查询
     *
     * @param problemId 主键
     * @return 实体对象
     */
    TabProblem selectByPrimaryKey(Integer problemId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabProblem record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabProblem record);

    List<TabProblem> listProblem(ProblemQO problemQO);

    List<ProblemDTO> listProblemByMemberId(@Param("memberId") Long memberId);
}