package com.gic.evaluate.service.impl;

import com.gic.commons.util.EntityUtil;
import com.gic.evaluate.constant.Constants;
import com.gic.evaluate.constant.ReplyEnum;
import com.gic.evaluate.dao.mapper.TabProblemMapper;
import com.gic.evaluate.dto.ProblemDTO;
import com.gic.evaluate.entity.TabProblem;
import com.gic.evaluate.qo.ProblemQO;
import com.gic.evaluate.service.ProblemService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-01-02 11:17
 */
@Service
public class ProblemServiceImpl implements ProblemService {

    @Autowired
    private TabProblemMapper tabProblemMapper;

    @Override
    public List<TabProblem> listProblem(ProblemQO problemQO) {
        return tabProblemMapper.listProblem(problemQO);
    }

    @Override
    public TabProblem getProblem(Integer problemId) {
        return tabProblemMapper.selectByPrimaryKey(problemId);
    }

    @Override
    public void updateProblem(ProblemDTO problemDTO) {
        TabProblem problem = EntityUtil.changeEntityByJSON(TabProblem.class, problemDTO);
        tabProblemMapper.updateByPrimaryKeySelective(problem);
    }

    @Override
    public Integer save(ProblemDTO problemDTO) {
        TabProblem problem = new TabProblem();
        problem.setEnterpriseId(problemDTO.getEnterpriseId());
        problem.setStoreId(problemDTO.getStoreId());
        problem.setStoreName(problemDTO.getStoreName());
        problem.setMemberId(problemDTO.getMemberId());
        problem.setMemberName(problemDTO.getMemberName());
        problem.setMemberPhone(problemDTO.getMemberPhone());
        problem.setProblemContent(problemDTO.getProblemContent());
        problem.setImageUrl(problemDTO.getImageUrl());
        problem.setHasOtherImage(problemDTO.getHasOtherImage());
        problem.setProblemStatus(ReplyEnum.WAIT.getCode());
        problem.setMaliciousStatus(Constants.CLOSE);
        problem.setShowStatus(Constants.OPEN);
        problem.setStatus(Constants.OPEN);
        problem.setCreateTime(new Date());
        return tabProblemMapper.insertSelective(problem);
    }

    @Override
    public List<ProblemDTO> listProblem(Long memberId) {
        return tabProblemMapper.listProblemByMemberId(memberId);
    }
}
